Attribute VB_Name = "mdMMClient2Server"
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Form:    mdMMClient2Server.frm                                *
'*Author:  Marco Magistrali - Funambol                          *
'****************************************************************

Function getStringAllItemsInFolderContactsOnFileSystem(ByRef contactsFolders() As FolderInfo, ByRef folderType As Integer)
Dim size As Integer
size = UBound(contactsFolders())
Dim objFolder As Outlook.MAPIFolder
Dim objItems As Outlook.Items
Dim intNumItems As Integer
Dim ret As String
Dim countItems As Long
Dim objFSO As Object
Dim fsoStream As Object

Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String

START_ROOT = TAG_START_CONTACTS
END_ROOT = TAG_END_CONTACTS
INTERNAL_START_ROOT = TAG_START_CONTACT
INTERNAL_END_ROOT = TAG_END_CONTACT

Dim I As Integer
intNumItems = 0

Set objFSO = CreateObject("Scripting.FileSystemObject")

Dim text As String
text = WAIT_PREPARING

For I = 1 To size
    Set objFolder = mdVariables.nameSpace.GetFolderFromID(contactsFolders(I).EntryID)
    
    ChangeStatusBar text + contactsFolders(I).name
    
    intNumItems = intNumItems + objFolder.Items.Count
    
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
     
    'handle each item
    For countItems = 1 To objFolder.Items.Count
        'error control first
        On Error Resume Next
        Err.Clear
        Set objItems = objFolder.Items
        
        If 0 <> Err.number Then
            logToDebug "Error : " & objFolder.Items(countItems) & vbNewLine & Err.Description
        ElseIf objItems Is Nothing Then
            logToDebug "The folder " & objFolder.name & " is empty"
        Else 'all is ok
                        
            If objItems.Item(countItems).Class = olDistributionList Then
               intNumItems = intNumItems - 1
            Else
            
                For K = 1 To UBound(props)
                    If folderType = FOLDER_TYPE_CON Then
                        props(K, 0) = mdVariables.contactsProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue( _
                            objItems.Item(countItems), mdVariables.contactsProperties(K).Property)
                    End If
                Next K
                
                ret = ""
                ret = ret + INTERNAL_START_ROOT
                
                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    'ret = ret + CStr(props(K, 1))
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"
    
                Next K
                
                ret = ret + "<Folder>" + contactsFolders(I).completePath + "</Folder>"
                ret = ret + INTERNAL_END_ROOT
                'logToDebug ret
                
                Set fsoStream = objFSO.CreateTextFile(objItems.Item(countItems).EntryID, True)
                fsoStream.WriteLine ret
                fsoStream.Close
                Set fsoStream = Nothing
                
                'Open objItems.Item(countItems).EntryID For Output As #1
                'ret = ret + "<Folder>" + contactsFolders(I).completePath + "</Folder>"
                'ret = ret + INTERNAL_END_ROOT
                'logToDebug ret
                'Write #1, ret 'write the type of items listed into
                'Close #1
                                             
            End If
        End If
                        
        ChangeStatusBar text + contactsFolders(I).name + " " + "(" + Str(countItems) + "/" + Str(objFolder.Items.Count) + ")"
                
        logToDebug Str(countItems)
    Next

Next I
    objFSO = Nothing
    
    ChangeStatusBar WAIT_SENDING_DATA
    
    getStringAllItemsInFolderContactsOnFileSystem = ret

End Function


Function getStringAllItemsInFolderContacts(ByRef contactsFolders() As FolderInfo, ByRef folderType As Integer)
Dim size As Integer
size = UBound(contactsFolders())
Dim objFolder As Outlook.MAPIFolder
Dim objItems As Outlook.Items
Dim intNumItems As Integer
Dim ret As String
Dim countItems As Long

Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String

START_ROOT = TAG_START_CONTACTS
END_ROOT = TAG_END_CONTACTS
INTERNAL_START_ROOT = TAG_START_CONTACT
INTERNAL_END_ROOT = TAG_END_CONTACT

Dim I As Integer
intNumItems = 0

For I = 1 To size
    Set objFolder = mdVariables.nameSpace.GetFolderFromID(contactsFolders(I).EntryID)

    intNumItems = intNumItems + objFolder.Items.Count
    'Dim numItems As String
    'numItems = "" & objFolder.Items.Count
    
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
     
    'handle each item
    For countItems = 1 To objFolder.Items.Count
        'error control first
        On Error Resume Next
        Err.Clear
        Set objItems = objFolder.Items
        
        If 0 <> Err.number Then
            logToDebug "Error : " & objFolder.Items(countItems) & vbNewLine & Err.Description
        ElseIf objItems Is Nothing Then
            logToDebug "The folder " & objFolder.name & " is empty"
        Else 'all is ok
                        
            If objItems.Item(countItems).Class = olDistributionList Then
               intNumItems = intNumItems - 1
            Else
            
                For K = 1 To UBound(props)
                    If folderType = FOLDER_TYPE_CON Then
                        props(K, 0) = mdVariables.contactsProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue( _
                            objItems.Item(countItems), mdVariables.contactsProperties(K).Property)
                    End If
                Next K
                
                ret = ret + "<row>"
                ret = ret + "<identifier>" + objItems.Item(countItems).EntryID + "</identifier>"
                ret = ret + "<bodyMsgValue>"
                ret = ret + INTERNAL_START_ROOT
                
                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    'ret = ret + CStr(props(K, 1))
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"
    
                Next K
                ret = ret + "<Folder>" + contactsFolders(I).completePath + "</Folder>"
                ret = ret + INTERNAL_END_ROOT
                ret = ret + "</bodyMsgValue>"
                ret = ret + "</row>"
            End If
        End If
        logToDebug Str(countItems)
    Next

Next I
        
    ret = "<numItems>" + Str(intNumItems) + "</numItems>" + ret
    ret = START_ROOT + ret
    ret = ret + END_ROOT
    
    logToDebug ret

    getStringAllItemsInFolderContacts = ret

End Function
       
Public Sub populateRecProps(ByRef RecProps As Variant, ByVal objItems As Outlook.AppointmentItem)
    
    
    Dim objItemRecurrence As Object
    Set objItemRecurrence = objItems.GetRecurrencePattern
    
    Dim recurrenceType As Long
    Dim interval As Long
    Dim monthOfYear As Long
    Dim dayOfMonth As Long
    Dim dayOfWeekMask As Long
    Dim instance As Long
    Dim patternStartDate As String
    Dim patterEndDate As String
    Dim noEndDate As Boolean
    Dim startAppointment As Date
    
    Dim x, y, z As Integer
    Dim changeDay, isBackward, changeYearBackward, changeYearForward   As Boolean
    changeDay = False
    isBackward = False
    changeYearBackward = False
    changeYearForward = False
    
    startAppointment = objItems.Start
    x = DatePart("h", startAppointment)
    startAppointment = mdMMTimeUtils.LocalToUTC_Date(startAppointment)
    y = DatePart("h", startAppointment)
    recurrenceType = objItemRecurrence.recurrenceType
    
    interval = objItemRecurrence.interval
    dayOfMonth = objItemRecurrence.dayOfMonth
    monthOfYear = objItemRecurrence.monthOfYear
    dayOfWeekMask = objItemRecurrence.dayOfWeekMask
    instance = objItemRecurrence.instance
    patternStartDate = mdMMTimeUtils.LocalToUTC(objItemRecurrence.patternStartDate)
    patterEndDate = mdMMTimeUtils.LocalToUTC(objItemRecurrence.PatternEndDate)
    noEndDate = objItemRecurrence.noEndDate
                                                    
    If x - y < 0 Then
        z = (x - y) * (-1)
    Else
        z = x - y
    End If
    
    If z > 12 Then
        changeDay = True
    Else
        changeDay = False
    End If
    
    If changeDay = True Then
        If getTimeZoneInfo = True Then
            isBackward = True
        Else
            isBackward = False
        End If
            
    End If
    
    'Assing every Value to for the property
     'Assing every Value to for the property
    RecProps(0, 0) = "RecurrenceType"
    RecProps(0, 1) = recurrenceType
    
    
    RecProps(1, 0) = "Interval"
    RecProps(1, 1) = interval
    
    
    If dayOfMonth <> 0 Then
            If changeDay = True Then
                If isBackward = True Then
                    dayOfMonth = dayOfMonth - 1
                    If dayOfMonth = 0 Then
                        If monthOfYear = 5 Or monthOfYear = 7 Or monthOfYear = 10 Then
                            ' if May, July, October the month before has 30 days
                            dayOfMonth = 30
                        Else
                            dayOfMonth = 31
                        End If
                            changeYearBackward = True
                    End If
                Else
                    dayOfMonth = dayOfMonth + 1
                    If dayOfMonth > 31 Or (dayOfMonth = 31 And (monthOfYear = 4 Or monthOfYear = 6 Or monthOfYear = 9)) Then
                        dayOfMonth = 1
                        changeYearForward = True
                    End If
                End If
            End If
            RecProps(2, 0) = "DayOfMonth"
            RecProps(2, 1) = dayOfMonth
            
     Else
        RecProps(2, 0) = "DayOfMonth"
        RecProps(2, 1) = 0
        
     End If
    
     If monthOfYear <> 0 Then
            If changeYearBackward = True Then
                monthOfYear = monthOfYear - 1
                If monthOfYear = 0 Then
                    monthOfYear = 12
                End If
            ElseIf changeYearForward = True Then
                monthOfYear = monthOfYear + 1
                If monthOfYear > 12 Then
                    monthOfYear = 1
                End If
            End If
            RecProps(3, 0) = "MonthOfYear"
            RecProps(3, 1) = monthOfYear
      Else
        RecProps(3, 0) = "MonthOfYear"
        RecProps(3, 1) = 0
            
      End If
    
      If dayOfWeekMask <> 0 Then
            If changeDay = True Then
                If isBackward = True Then
                    dayOfWeekMask = convertDayOfWeekMaskBackward(dayOfWeekMask)
                Else
                    dayOfWeekMask = convertDayOfWeekMaskForward(dayOfWeekMask)
                End If
            End If
            RecProps(4, 0) = "DayOfWeekMask"
            RecProps(4, 1) = dayOfWeekMask
     Else
        RecProps(4, 0) = "DayOfWeekMask"
        RecProps(4, 1) = 0
     End If
     
     If instance <> 0 Then
        RecProps(5, 0) = "Instance"
        RecProps(5, 1) = instance
            
     Else
        RecProps(5, 0) = "Instance"
        RecProps(5, 1) = 0
     End If
     
     RecProps(6, 0) = "PatternStartDate"
     RecProps(6, 1) = patternStartDate
     
     RecProps(7, 0) = "PatternEndDate"
     RecProps(7, 1) = PatternEndDate
     
     RecProps(8, 0) = "NoEndDate"
     RecProps(8, 1) = noEndDate
     

End Sub

Public Function getRecurrenceValue(ByRef RecProps() As Variant, ByVal propertyName As String)

    Dim I, up As Integer
    up = UBound(RecProps)
    For I = 0 To up
        If RecProps(I, 0) = propertyName Then
            getRecurrenceValue = RecProps(I, 1)
            Exit Function
        End If
        
    Next I

End Function

Function getStringAllItemsInFolder(ByRef objFolder As Outlook.MAPIFolder, ByRef folderType As Integer)
    'prepare the file NAME_ALL_FILE, listing all the items in the olFolder objFolder

Dim objItems As Outlook.Items
Dim objItemRecurrence As Object
Dim countItems As Long
Dim writingLine As String

Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String

'prepare the string to write in the file with the type of item
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    INTERNAL_START_ROOT = TAG_START_CALENDAR
    INTERNAL_END_ROOT = TAG_END_CALENDAR
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    INTERNAL_START_ROOT = TAG_START_CONTACT
    INTERNAL_END_ROOT = TAG_END_CONTACT
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Tasks"
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    INTERNAL_START_ROOT = TAG_START_TASK
    INTERNAL_END_ROOT = TAG_END_TASK
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Tasks"
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES
    INTERNAL_START_ROOT = TAG_START_NOTE
    INTERNAL_END_ROOT = TAG_END_NOTE
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
       
Case mdVariables.FOLDER_TYPE_MAIL
    'writingLine = "Mail"
End Select

Dim intNumItems As Integer
intNumItems = objFolder.Items.Count
Dim numItems As String
numItems = "" & intNumItems

Dim ret As String

    ret = START_ROOT
    ret = ret + "<numItems>" + numItems + "</numItems>"
             
    'handle each item
    For countItems = 1 To objFolder.Items.Count
        'error control first
        On Error Resume Next
        Err.Clear
        Set objItems = objFolder.Items
        If 0 <> Err.number Then
            logToDebug "Error : " & objFolder.Items(countItems) & vbNewLine & Err.Description
        ElseIf objItems Is Nothing Then
            logToDebug "The folder " & objFolder.name & " is empty"
        Else 'all is ok
            If folderType = FOLDER_TYPE_CAL Then
                Dim RecProps() As Variant
                ReDim RecProps(0 To 9, 0 To 1)
                'Set objItemRecurrence = objItems.Item(countItems).GetRecurrencePattern
                
                'used for recurrence
                mdMMClient2Server.populateRecProps RecProps, objItems.Item(countItems)
                                                                
            End If
            
            For K = 1 To UBound(props)
                If folderType = FOLDER_TYPE_CON Then
                    props(K, 0) = mdVariables.contactsProperties(K).Property
                    props(K, 1) = mdActions.getItemPropertyValue( _
                        objItems.Item(countItems), mdVariables.contactsProperties(K).Property)
                
                ElseIf folderType = FOLDER_TYPE_CAL Then
                    props(K, 0) = mdVariables.calendarProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) Then
                        props(K, 1) = mdMMClient2Server.getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                    
                        'props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                        '    mdVariables.calendarProperties(K).Property)
                    Else
                        props(K, 1) = mdActions.getItemPropertyValue(objItems.Item(countItems), _
                            mdVariables.calendarProperties(K).Property)
                    End If
                                    
                ElseIf folderType = FOLDER_TYPE_TASK Then
                    props(K, 0) = mdVariables.tasksProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                    
                        props(K, 1) = mdActions.getItemPropertyValue(objItems.Item(countItems), _
                            mdVariables.tasksProperties(K).Property)
                    End If
                                    
                ElseIf folderType = FOLDER_TYPE_NOTE Then
                    props(K, 0) = mdVariables.notesProperties(K).Property
                    props(K, 1) = mdActions.getItemPropertyValue(objItems.Item(countItems), _
                        mdVariables.notesProperties(K).Property)
                                        
                End If
                
            Next K
            
            ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
            ' IsRecurring property to True also if it isn't!!
            If folderType = FOLDER_TYPE_TASK Then
                Set objItemRecurrence = objItems.Item(countItems).GetRecurrencePattern
                For K = 1 To UBound(props)
                    props(K, 0) = mdVariables.tasksProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                        props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            mdVariables.tasksProperties(K).Property)
                    End If
                Next K
            End If
            
            ret = ret + "<row>"
            ret = ret + "<identifier>" + objItems.Item(countItems).EntryID + "</identifier>"
            ret = ret + "<bodyMsgValue>"
            ret = ret + INTERNAL_START_ROOT
            
            For K = 1 To UBound(props)
                ret = ret + "<" + CStr(props(K, 0)) + ">"
                'ret = ret + CStr(props(K, 1))
                ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                ret = ret + "</" + CStr(props(K, 0)) + ">"

            Next K
                      
            ret = ret + INTERNAL_END_ROOT
            ret = ret + "</bodyMsgValue>"
            ret = ret + "</row>"
    
        End If
    Next
    
    ret = ret + END_ROOT
    logToDebug ret

getStringAllItemsInFolder = ret

End Function

Function getStringNewItemsInFolderContacts(ByRef folderType As Integer)
    'usato per i contacts
Dim objItem As Object
Dim objItemRecurrence As Object
Dim I As Integer

Dim extraItems As Integer
extraItems = -1
Dim extraNew() As Variant

Dim ret As String
ret = ""
Dim numItems As Integer
numItems = -1
    
Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String
       
Dim totalNumItems As Integer
totalNumItems = 0
              
Dim text As String
text = WAIT_PREPARING_NEW

              
Select Case folderType
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    INTERNAL_START_ROOT = TAG_START_CONTACT
    INTERNAL_END_ROOT = TAG_END_CONTACT
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    
End Select
    
On Error GoTo getStringErrorManager
                     
        extraNew = getAllNewItemNameFromFile
        extraItems = UBound(extraNew, 2)
        numItems = UBound(mdVariables.createdListMM, 2)
        
        If numItems <> -1 Or extraItems <> -1 Then
            totalNumItems = numItems + 1 + extraItems + 1
            
            'Dim st As String
            'st = Str(numItems + 1 + extraItems + 1)
            'ret = START_ROOT
            'ret = ret + "<numItems>" + Trim(st) + "</numItems>"
        
            For I = 0 To numItems
                'Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.createdList(I))
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.createdListMM(0, I))
                                             
                If objItem.Class = olDistributionList Then 'to avoid distribution list
                    logToDebug ("It's a distributionList: not sync - ADD")
                    totalNumItems = totalNumItems - 1
                    
                Else
                                                        
                    For K = 1 To UBound(props)
                        If folderType = FOLDER_TYPE_CON Then
                            props(K, 0) = mdVariables.contactsProperties(K).Property
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.contactsProperties(K).Property)
                        End If
                    
                    Next K
                                                      
                    ret = ret + "<row>"
                    ret = ret + "<identifier>" + objItem.EntryID + "</identifier>"
                    ret = ret + "<bodyMsgValue>"
                    ret = ret + INTERNAL_START_ROOT
                    ' create all xml structure
                    For K = 1 To UBound(props)
                        ret = ret + "<" + CStr(props(K, 0)) + ">"
                        'ret = ret + CStr(props(K, 1))
                        ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                        ret = ret + "</" + CStr(props(K, 0)) + ">"
    
                    Next K
                        ret = ret + "<Folder>" + mdVariables.createdListMM(1, I) + "</Folder>"
                        
                    ret = ret + INTERNAL_END_ROOT
                    ret = ret + "</bodyMsgValue>"
                    ret = ret + "</row>"
                
                End If
            Next
            
            For I = 0 To extraItems
                'Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.createdList(I))
                Set objItem = mdVariables.nameSpace.GetItemFromID(extraNew(0, I))
                
                If objItem.Class = olDistributionList Then 'to avoid distribution list
                    logToDebug ("It's a extra distributionList: not sync - ADD")
                    totalNumItems = totalNumItems - 1
                    
                Else
                                              
                For K = 1 To UBound(props)
                        If folderType = FOLDER_TYPE_CON Then
                            props(K, 0) = mdVariables.contactsProperties(K).Property
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.contactsProperties(K).Property)
                        End If
                    
                    Next K
                                                      
                    ret = ret + "<row>"
                    ret = ret + "<identifier>" + objItem.EntryID + "</identifier>"
                    ret = ret + "<bodyMsgValue>"
                    ret = ret + INTERNAL_START_ROOT
                    ' create all xml structure
                    For K = 1 To UBound(props)
                        ret = ret + "<" + CStr(props(K, 0)) + ">"
                        'ret = ret + CStr(props(K, 1))
                        ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                        ret = ret + "</" + CStr(props(K, 0)) + ">"
    
                    Next K
                        ret = ret + "<Folder>" + extraNew(1, I) + "</Folder>"
                        
                    ret = ret + INTERNAL_END_ROOT
                    ret = ret + "</bodyMsgValue>"
                    ret = ret + "</row>"
                End If
            Next
            
            If totalNumItems > -1 Then
                Dim st As String
                st = Str(totalNumItems)
                ret = START_ROOT + "<numItems>" + Trim(st) + "</numItems>" + ret + END_ROOT
            
                'ret = ret + END_ROOT
            End If
            
        End If
        logToDebug ret
    
    getStringNewItemsInFolderContacts = ret
    
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
      
    
End Function

Function getStringNewItemsInFolder(ByRef folderType As Integer)
    'usato per i contacts
Dim objItem As Object
Dim objItemRecurrence As Object
Dim I As Integer

Dim ret As String
ret = ""
Dim numItems As Integer
numItems = -1
    
Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String
       
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    INTERNAL_START_ROOT = TAG_START_CALENDAR
    INTERNAL_END_ROOT = TAG_END_CALENDAR
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    INTERNAL_START_ROOT = TAG_START_CONTACT
    INTERNAL_END_ROOT = TAG_END_CONTACT
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Task"
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    INTERNAL_START_ROOT = TAG_START_TASK
    INTERNAL_END_ROOT = TAG_END_TASK
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Notes"
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES
    INTERNAL_START_ROOT = TAG_START_NOTE
    INTERNAL_END_ROOT = TAG_END_NOTE
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    
End Select
    
On Error GoTo getStringErrorManager
                
        numItems = UBound(mdVariables.createdList)
        If numItems <> -1 And mdVariables.createdList(0) <> "-1" Then
        'If numItems <> -1 Then
            Dim st As String
            st = Str(numItems + 1)
            ret = START_ROOT
            ret = ret + "<numItems>" + Trim(st) + "</numItems>"
                    
        
            For I = 0 To numItems
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.createdList(I))
                
                If folderType = FOLDER_TYPE_CAL Then
                    Dim RecProps() As Variant
                    ReDim RecProps(0 To 9, 0 To 1)
                    'Set objItemRecurrence = objItems.Item(countItems).GetRecurrencePattern
                    
                    'used for recurrence
                    mdMMClient2Server.populateRecProps RecProps, objItem
                                                                
                End If
               
                For K = 1 To UBound(props)
                    If folderType = FOLDER_TYPE_CON Then
                        props(K, 0) = mdVariables.contactsProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.contactsProperties(K).Property)
                    ElseIf folderType = FOLDER_TYPE_CAL Then
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) = True Then
                            props(K, 1) = mdMMClient2Server.getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                            'props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            '    mdVariables.calendarProperties(K).Property)
                            
                        Else
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, _
                                mdVariables.calendarProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_TASK Then
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                            'props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            '    mdVariables.tasksProperties(K).Property)
                        
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_NOTE Then
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.notesProperties(K).Property)
                    End If
                
                Next K
                  
                ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
                ' IsRecurring property to True also if it isn't!!
                If folderType = FOLDER_TYPE_TASK Then
                    Set objItemRecurrence = objItem.GetRecurrencePattern
                    For K = 1 To UBound(props)
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                            props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    Next K
                End If
                  
                  
                ret = ret + "<row>"
                ret = ret + "<identifier>" + objItem.EntryID + "</identifier>"
                ret = ret + "<bodyMsgValue>"
                ret = ret + INTERNAL_START_ROOT
                ' create all xml structure
                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    'ret = ret + CStr(props(K, 1))
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"

                Next K
                
                ret = ret + INTERNAL_END_ROOT
                ret = ret + "</bodyMsgValue>"
                ret = ret + "</row>"
            Next
            ret = ret + END_ROOT
            
        End If
        logToDebug ret
    
    getStringNewItemsInFolder = ret
    
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
      
    
End Function
Function getStringModItemsInFolderContacts(ByRef folderType As Integer)
    'used to sync contacts subfolders
    
    Dim objItem As Object
    Dim objItemRecurrence As Object
       
    Dim I As Integer
    
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
    Dim props() As Variant
    Dim K As Integer
    Dim START_ROOT As String
    Dim END_ROOT As String
    Dim INTERNAL_START_ROOT As String
    Dim INTERNAL_END_ROOT As String
               
    Dim totalNumItems As Integer
    totalNumItems = 0
               
    Select Case folderType
        Case mdVariables.FOLDER_TYPE_CON
            'writingLine = "Contacts"
            START_ROOT = TAG_START_CONTACTS
            END_ROOT = TAG_END_CONTACTS
            INTERNAL_START_ROOT = TAG_START_CONTACT
            INTERNAL_END_ROOT = TAG_END_CONTACT
            ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    End Select
        
    On Error GoTo getStringErrorManager
       
        numItems = UBound(mdVariables.modifiedListMM, 2)
        If numItems <> -1 Then
            
            totalNumItems = numItems + 1
            'Dim st As String
            'st = Str(numItems + 1)
            'ret = START_ROOT
            'ret = ret + "<numItems>" + Trim(st) + "</numItems>"
        
            For I = 0 To numItems
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.modifiedListMM(0, I))
                
                 If objItem.Class = olDistributionList Then 'to avoid distribution list
                    logToDebug ("It's a extra distributionList: not sync - MOD")
                    totalNumItems = totalNumItems - 1
                    
                 Else
                                
                    For K = 1 To UBound(props)
                        If folderType = FOLDER_TYPE_CON Then
                            props(K, 0) = mdVariables.contactsProperties(K).Property
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.contactsProperties(K).Property)
                        End If
                    Next K
                    
                    ret = ret + "<row>"
                    ret = ret + "<identifier>" + objItem.EntryID + "</identifier>"
                    ret = ret + "<bodyMsgValue>"
                    ret = ret + INTERNAL_START_ROOT
                   ' create all xml structure
                    For K = 1 To UBound(props)
                        ret = ret + "<" + CStr(props(K, 0)) + ">"
                        ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                        'ret = ret + CStr(props(K, 1))
                        ret = ret + "</" + CStr(props(K, 0)) + ">"
    
                    Next K
                    
                    ret = ret + "<Folder>" + mdVariables.modifiedListMM(1, I) + "</Folder>"
                    ret = ret + INTERNAL_END_ROOT
                    ret = ret + "</bodyMsgValue>"
                    ret = ret + "</row>"
                End If
                
            Next
            
            If totalNumItems > -1 Then
                Dim st As String
                st = Str(totalNumItems)
                ret = START_ROOT + "<numItems>" + Trim(st) + "</numItems>" + ret + END_ROOT
            
                'ret = ret + END_ROOT
            End If
        End If
    
        logToDebug ret
            
getStringModItemsInFolderContacts = ret
        
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
   
End Function


Function getStringModItemsInFolder(ByRef folderType As Integer)
    'usato per i contacts
    Dim objItem As Object
    Dim objItemRecurrence As Object
       
    Dim I As Integer
    
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
    Dim props() As Variant
    Dim K As Integer
    Dim START_ROOT As String
    Dim END_ROOT As String
    Dim INTERNAL_START_ROOT As String
    Dim INTERNAL_END_ROOT As String
           
    Select Case folderType
    Case mdVariables.FOLDER_TYPE_CAL
        'writingLine = "Calendar"
        START_ROOT = TAG_START_CALENDARS
        END_ROOT = TAG_END_CALENDARS
        INTERNAL_START_ROOT = TAG_START_CALENDAR
        INTERNAL_END_ROOT = TAG_END_CALENDAR
        ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
        
    Case mdVariables.FOLDER_TYPE_CON
        'writingLine = "Contacts"
        START_ROOT = TAG_START_CONTACTS
        END_ROOT = TAG_END_CONTACTS
        INTERNAL_START_ROOT = TAG_START_CONTACT
        INTERNAL_END_ROOT = TAG_END_CONTACT
        ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
        
    Case mdVariables.FOLDER_TYPE_TASK
        'writingLine = "Task"
        START_ROOT = TAG_START_TASKS
        END_ROOT = TAG_END_TASKS
        INTERNAL_START_ROOT = TAG_START_TASK
        INTERNAL_END_ROOT = TAG_END_TASK
        ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    
    Case mdVariables.FOLDER_TYPE_NOTE
        'writingLine = "Note"
        START_ROOT = TAG_START_NOTES
        END_ROOT = TAG_END_NOTES
        INTERNAL_START_ROOT = TAG_START_NOTE
        INTERNAL_END_ROOT = TAG_END_NOTE
        ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
        
    End Select
        
    On Error GoTo getStringErrorManager
       
        numItems = UBound(mdMMVariables.modItems)
        'If numItems <> -1 Then
        If numItems <> -1 And mdMMVariables.modItems(0) <> "-1" Then
            Dim st As String
            st = Str(numItems + 1)
            ret = START_ROOT
            ret = ret + "<numItems>" + Trim(st) + "</numItems>"
        
            For I = 0 To numItems
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdMMVariables.modItems(I))
                If folderType = FOLDER_TYPE_CAL Then
                    Dim RecProps() As Variant
                    ReDim RecProps(0 To 9, 0 To 1)
                    'Set objItemRecurrence = objItems.Item(countItems).GetRecurrencePattern
                    
                    'used for recurrence
                    mdMMClient2Server.populateRecProps RecProps, objItem
                                                                
                End If
                
                For K = 1 To UBound(props)
                    If folderType = FOLDER_TYPE_CON Then
                        props(K, 0) = mdVariables.contactsProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.contactsProperties(K).Property)
                    ElseIf folderType = FOLDER_TYPE_CAL Then
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) = True Then
                            props(K, 1) = mdMMClient2Server.getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                            'props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            '    mdVariables.calendarProperties(K).Property)
                        Else
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, _
                                mdVariables.calendarProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_TASK Then
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                            'props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            '    mdVariables.tasksProperties(K).Property)
                        
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_NOTE Then
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.notesProperties(K).Property)
                    End If
                
                Next K
                
                ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
                ' IsRecurring property to True also if it isn't!!
                If folderType = FOLDER_TYPE_TASK Then
                    Set objItemRecurrence = objItem.GetRecurrencePattern
                    For K = 1 To UBound(props)
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                            props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    Next K
                End If
                
                ret = ret + "<row>"
                ret = ret + "<identifier>" + objItem.EntryID + "</identifier>"
                ret = ret + "<bodyMsgValue>"
                ret = ret + INTERNAL_START_ROOT
               ' create all xml structure
                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    'ret = ret + CStr(props(K, 1))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"

                Next K
                ret = ret + INTERNAL_END_ROOT
                ret = ret + "</bodyMsgValue>"
                ret = ret + "</row>"
            Next
            ret = ret + END_ROOT
        End If
    
        logToDebug ret
            
getStringModItemsInFolder = ret
        
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
   
End Function

Function getStringDelItemsInFolderContacts(ByRef folderType As Integer)
    'usato per i contacts
    'per i deleted mando solo gli id
    Dim objItem As Object
    Dim I As Integer
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
    Dim extraItems As Integer
    extraItems = -1
    
    Dim totalNumItems As Integer
    totalNumItems = 0
    
    Dim K As Integer
    Dim START_ROOT As String
    Dim END_ROOT As String
       
    Dim extraDeleted() As String
    
    Select Case folderType
    
        Case mdVariables.FOLDER_TYPE_CON
            'writingLine = "Contacts"
            START_ROOT = TAG_START_CONTACTS
            END_ROOT = TAG_END_CONTACTS

    End Select
       
    On Error Resume Next
        
        extraDeleted = getAllNameFolderFromFile
        extraItems = UBound(extraDeleted)
        
        numItems = UBound(mdVariables.deletedListMM, 2)
        
        If numItems <> -1 Or extraItems <> -1 Then
            
            totalNumItems = numItems
            Set objItem = Nothing
            'Dim st As String
            'st = Str(numItems + 1 + extraItems + 1)
            'ret = START_ROOT
            'ret = ret + "<numItems>" + Trim(st) + "</numItems>"
        
            For I = 0 To numItems
                Set objItem = Nothing
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.deletedListMM(0, I))
                
                If Not objItem Is Nothing Then
                    If objItem.Class = olDistributionList Then   'to avoid distribution list
                        logToDebug ("It's a extra distributionList: not sync - DEL")
                        totalNumItems = totalNumItems - 1
                    
                    Else
                        ret = ret + "<row>"
                        ret = ret + "<identifier>" + mdVariables.deletedListMM(0, I) + "</identifier>"
                        ret = ret + "</row>"
                    End If
                Else
                    totalNumItems = totalNumItems - 1
                End If
             Next
             
            For I = 0 To extraItems
                Set objItem = Nothing
                Set objItem = mdVariables.nameSpace.GetItemFromID(extraDeleted(I))
                
                If Not objItem Is Nothing Then
                    If objItem.Class = olDistributionList Then   'to avoid distribution list
                        logToDebug ("It's a extra distributionList: not sync - DEL")
                        totalNumItems = totalNumItems - 1
                    
                    Else
                    ret = ret + "<row>"
                    ret = ret + "<identifier>" + extraDeleted(I) + "</identifier>"
                    ret = ret + "</row>"
                    End If
                Else
                    totalNumItems = totalNumItems - 1
                End If
            Next
            
            If totalNumItems > -1 Then
                Dim st As String
                st = Str(totalNumItems)
                ret = START_ROOT + "<numItems>" + Trim(st) + "</numItems>" + ret + END_ROOT
            
                'ret = ret + END_ROOT
            End If
            
        End If
    
    logToDebug ret
    getStringDelItemsInFolderContacts = ret
    
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    Case 6
        Resume Next
    End Select
    
    
End Function

Function getStringDelItemsInFolder(ByRef folderType As Integer)
    'usato per i contacts
    'per i deleted mando solo gli id
    Dim objItem As Object
    Dim I As Integer
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String

       
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "task"
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "note"
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES

End Select
       
On Error GoTo getStringErrorManager
   
        numItems = UBound(mdMMVariables.delItems)
        'If numItems <> -1 Then
        If numItems <> -1 And mdMMVariables.delItems(0) <> "-1" Then
            Dim st As String
            st = Str(numItems + 1)
            ret = START_ROOT
            ret = ret + "<numItems>" + Trim(st) + "</numItems>"
        
            For I = 0 To numItems
                
                ret = ret + "<row>"
                ret = ret + "<identifier>" + mdMMVariables.delItems(I) + "</identifier>"
                ret = ret + "</row>"
                
            Next
            ret = ret + END_ROOT
        End If
    
    logToDebug ret
    getStringDelItemsInFolder = ret
    
getStringErrorManager_Exit:
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
    
    
End Function


