Attribute VB_Name = "mdMMServer2Client"
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Form:    mdMMServer2Client.frm                                *
'*Author:  Marco Magistrali - Funambol                          *
'****************************************************************




'from server to outlook
Function updateItem(ByVal xml As String, ByRef folderType As Integer, ByRef countInsertedItems As Integer)

Dim ret As String

Dim position As Long
Dim numItem As Integer
Dim I As Integer
Dim J As Integer
Dim Count As Integer

Dim identifier As String
Dim rowBlock As String
Dim xmlMapping As String
xmlMapping = ""
Dim props() As Variant
Dim K As Integer
Dim found As Boolean
       
'Dim myOlApp As Outlook.Application
Dim myApptItem As Outlook.AppointmentItem
Dim myContactItem As Outlook.ContactItem
Dim myTaskItem As Outlook.TaskItem
Dim myNoteItem As Outlook.NoteItem
Dim myRecurrPAtt As Outlook.RecurrencePattern
Dim createdEntryID  As String
'Set myOlApp = New Outlook.Application
Dim res As String
      
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    'Count = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderCalendar).Items.Count
    Count = mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar).Items.Count
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    'Count = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderContacts).Items.Count
    Count = mdVariables.nameSpace.GetDefaultFolder(olFolderContacts).Items.Count
    
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Task"
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    'Count = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderTasks).Items.Count
    Count = mdVariables.nameSpace.GetDefaultFolder(olFolderTasks).Items.Count

Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Note"
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    'Count = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderNotes).Items.Count
    Count = mdVariables.nameSpace.GetDefaultFolder(olFolderNotes).Items.Count

End Select

I = 0
position = 1

ret = getElementContent(xml, "MOD", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    numItem = getElementContent(ret, "numItems", 0)
    For I = 0 To Val(numItem) - 1
                
        rowBlock = getElementContent(ret, "row", position)
        
        identifier = getElementContent(rowBlock, "identifier", 0)
        
        If folderType = FOLDER_TYPE_CAL Then
            props(0, 0) = "Class"
            props(0, 1) = 26
            
            'for recurrence
            Dim RecProps() As Variant
            ReDim RecProps(0 To 9, 0 To 1)
            mdMMServer2Client.populateRecProps RecProps, rowBlock
                
        End If
        
        Dim s As String
        For K = 1 To UBound(props)
            If folderType = FOLDER_TYPE_CON Then
                Dim tmp As Variant
                props(K, 0) = mdVariables.contactsProperties(K).Property
                
                tmp = returnElementDataTypeCorrect(props(K, 0), _
                    getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0))
                props(K, 1) = tmp
            ElseIf folderType = FOLDER_TYPE_CAL Then
                
                props(K, 0) = mdVariables.calendarProperties(K).Property
                If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) Then
                    props(K, 1) = getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                Else
                    'put right type to every property. If date is empty put nothing
                    tmp = returnElementDataTypeCorrect(props(K, 0), _
                        getElementContent(rowBlock, mdVariables.calendarProperties(K).Property, 0))
                    props(K, 1) = tmp
                End If
            ElseIf folderType = FOLDER_TYPE_TASK Then
                                                            
                props(K, 0) = mdVariables.tasksProperties(K).Property
                
                'put right type to every property. If date is empty put nothing
                tmp = returnElementDataTypeCorrect(props(K, 0), _
                 getElementContent(rowBlock, mdVariables.tasksProperties(K).Property, 0))
                props(K, 1) = tmp
            ElseIf folderType = FOLDER_TYPE_NOTE Then
                If mdVariables.notesProperties(K).Property <> "Subject" Then
                    
                    Dim tmpNote As Variant
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        tmpNote = defaultNoteValues(props(K, 0), getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0))
                        props(K, 1) = tmpNote

                End If
            End If
        
        Next K
                
        found = False
        
        If folderType = FOLDER_TYPE_CAL Then
            
            If Count = 0 Then
                printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CAL, props)
                'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                'countInsertedItems = countInsertedItems + 1
            Else
                For J = 1 To Count
                    
                    Set myApptItem = mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar).Items(J)
                    
                    If myApptItem.EntryID = identifier Then
                        
                        res = mdActions.updateItemCalendar(identifier, props(), folderType)
                        If res = "-1" Then
                            printLog ERROR_UPDATING_ITEM & rowBlock, INFO_LEVEL
                        End If
                        
                        found = True
                    End If
                Next J
                If found = False Then
                    printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                    'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CAL, props)
                    'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                    'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                    'countInsertedItems = countInsertedItems + 1
                End If
            End If
        
        ElseIf folderType = FOLDER_TYPE_TASK Then
            
            If Count = 0 Then
                printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_TASK, props)
                'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                'countInsertedItems = countInsertedItems + 1
            Else
                For J = 1 To Count
                    'Set myTaskItem = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderTasks).Items(J)
                    Set myTaskItem = mdVariables.nameSpace.GetDefaultFolder(olFolderTasks).Items(J)
                    
                    If myTaskItem.EntryID = identifier Then
                        'used also for update task
                        res = mdActions.updateItemCalendar(identifier, props(), folderType)
                        If res = "-1" Then
                            printLog ERROR_UPDATING_ITEM & rowBlock, INFO_LEVEL
                        End If
                        found = True
                    End If
                Next J
                If found = False Then
                    printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                    'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_TASK, props)
                    'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                    'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                    'countInsertedItems = countInsertedItems + 1
                End If
            End If
        
        ElseIf folderType = FOLDER_TYPE_CON Then 'modify for contacts
            If Count = 0 Then
                printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
                'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                'countInsertedItems = countInsertedItems + 1
            Else
                For J = 1 To Count
                    'Set myContactItem = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderContacts).Items(J)
                    Set myContactItem = mdVariables.nameSpace.GetDefaultFolder(olFolderContacts).Items(J)
                    If myContactItem.EntryID = identifier Then
                        
                        res = mdActions.updateItem(identifier, props)
                        
                        If res = "-1" Then
                            printLog ERROR_UPDATING_ITEM & rowBlock, INFO_LEVEL
                        End If
                        
                        found = True
                    End If
                Next J
                If found = False Then
                    printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                    'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
                    'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                    'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                    'countInsertedItems = countInsertedItems + 1
                End If
            End If
         
         ElseIf folderType = FOLDER_TYPE_NOTE Then 'modify for notes
            If Count = 0 Then
                printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_NOTE, props)
                'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                'countInsertedItems = countInsertedItems + 1
            Else
                For J = 1 To Count
                    'Set myNoteItem = myOlApp.GetNamespace("MAPI").GetDefaultFolder(olFolderNotes).Items(J)
                    Set myNoteItem = mdVariables.nameSpace.GetDefaultFolder(olFolderNotes).Items(J)
                    If myNoteItem.EntryID = identifier Then
                        
                        res = mdActions.updateItem(identifier, props)
                        If res = "-1" Then
                            printLog ERROR_UPDATING_ITEM & rowBlock, INFO_LEVEL
                        End If
                        found = True
                    End If
                Next J
                If found = False Then
                    printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                    'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_NOTE, props)
                    'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                    'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
                    'countInsertedItems = countInsertedItems + 1
                End If
            End If
            
        End If
        
    Next

End If

updateItem = xmlMapping

End Function

'from server to outlook for contact subfolders
Function updateItemContacts(ByVal xml As String, ByRef folderType As Integer, ByRef countInsertedItems As Integer)

Dim ret As String

Dim position As Long
Dim numItem As Integer
Dim I As Integer
Dim J As Integer
Dim Count As Integer

Dim identifier As String
Dim rowBlock As String
Dim xmlMapping As String
xmlMapping = ""
Dim props() As Variant
Dim K As Integer
Dim found As Boolean
       
'Dim myOlApp As Outlook.Application

Dim myContactItem As Outlook.ContactItem
Dim createdEntryID  As String
             
Select Case folderType
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
   
End Select

I = 0
position = 1

On Error Resume Next

ret = getElementContent(xml, "MOD", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    numItem = getElementContent(ret, "numItems", 0)
    
    For I = 0 To Val(numItem) - 1
        myContactItem = Nothing
        
        ChangeStatusBar WAIT_PROCESSING_UPDATE + "(" + Str(I + 1) + "/" + Str(numItem) + ")"
        
        rowBlock = getElementContent(ret, "row", position)
        
        identifier = getElementContent(rowBlock, "identifier", 0)
    
        Dim s As String
        For K = 1 To UBound(props)
            If folderType = FOLDER_TYPE_CON Then
                Dim tmp As Variant
                props(K, 0) = mdVariables.contactsProperties(K).Property
                
                tmp = returnElementDataTypeCorrect(props(K, 0), _
                    getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0))
                props(K, 1) = tmp
            End If
        
        Next K
                
        Set myContactItem = mdVariables.nameSpace.GetItemFromID(identifier)
        
        If myContactItem Is Nothing Then  'the item to modify was not found. It has to be created
            
            'create the item using what there is in addItemContacts
            'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
            printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
            'createdEntryID = insertContact(rowBlock, props)
            
            'xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
            'xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
            'countInsertedItems = countInsertedItems + 1
        
        Else
                                    
            mdActions.updateItem identifier, props
                
        End If
        
    Next

End If

updateItemContacts = xmlMapping

End Function

Function insertContact(ByRef rowBlock As String, ByRef props() As Variant)
            
            Dim defaultFolderContacts As Outlook.MAPIFolder
            Dim itemContact As Outlook.ContactItem
            Dim referFolder As Outlook.MAPIFolder
            Dim K As Integer
            Dim createdEntryID As String
            Dim folderToPutItem As String
            
            Set defaultFolderContacts = mdVariables.nameSpace.GetDefaultFolder(olFolderContacts)
            
            folderToPutItem = getElementContent(rowBlock, "Folder", 0)
                        
            If Left(folderToPutItem, 1) = "/" And Len(folderToPutItem) > 1 Then
                folderToPutItem = Mid(folderToPutItem, 2)
            End If
            
            If Right(folderToPutItem, 1) = "/" And Len(folderToPutItem) > 1 Then
                folderToPutItem = Mid(folderToPutItem, 1, Len(folderToPutItem) - 1)
            End If
            
            If folderToPutItem = "/" Then
                folderToPutItem = ""
            End If
                                                                                           
            'to test if a folder arleady exists
            Dim exists As Boolean
            Dim directories() As String
            Dim CompletePath As String
            Dim m As Integer
            Dim N As Integer
            N = -1
            CompletePath = "/"
            exists = False
            
            directories = Split(folderToPutItem, "/")
            N = UBound(directories)
                        
            Set referFolder = defaultFolderContacts
            For m = 0 To N
                CompletePath = CompletePath + directories(m) + "/"
                For K = 1 To referFolder.Folders.Count
                    If directories(m) = referFolder.Folders(K).name Then
                        exists = True
                        Set referFolder = referFolder.Folders(directories(m))
                        Exit For
                    End If
                Next K
                'folder doesn't exist. create a new one and set complete path
                If exists = False Then
                    Set referFolder = referFolder.Folders.Add(directories(m))
                    ReDim Preserve mdVariables.contactsFolders(UBound(mdVariables.contactsFolders) + 1)
                    Dim folderInfoElement As FolderInfo
                    folderInfoElement.EntryID = referFolder.EntryID
                    folderInfoElement.Selected = True
                    folderInfoElement.Changed = True
                    folderInfoElement.name = directories(m)
                    folderInfoElement.CompletePath = CompletePath
                    mdVariables.contactsFolders(UBound(mdVariables.contactsFolders)) = folderInfoElement
                    MkDir referFolder.EntryID
                End If
                exists = False
            Next m
            
            'add the contact int selected folder
            Dim fileas As String
            Set itemContact = referFolder.Items.Add
            'loop through newItemProperties array reading the Item properties and values to assign to the new item
            For K = 1 To UBound(props)
                
                'to get the right value for calendar birthday
                If CStr(props(K, 0)) = "FileAs" Then
                    fileas = props(K, 1)
                End If
                
                If CStr(props(K, 0)) = "Subject" Then
                    If props(K, 1) = Empty Or props(K, 1) = "" Then
                        props(K, 1) = fileas
                    End If
                End If
                
                mdActions.letItemPropertyValue itemContact, CStr(props(K, 0)), props(K, 1)
                
            Next K
            
            itemContact.Save
            createdEntryID = itemContact.EntryID
            
            insertContact = createdEntryID

End Function

'from server to outlook
Function addItemContacts(ByRef xml As String, ByRef folderType As Integer, ByRef countInsertedItems As Integer)

Dim ret As String
Dim el As String
Dim ROOT As String
Dim referFolder As Outlook.MAPIFolder
Dim defaultFolderContacts As Outlook.MAPIFolder
Dim itemContact As Outlook.ContactItem

Dim position As Long
Dim numItem As Integer
Dim numItemValid As Integer
numItemValid = 0

Dim I As Integer
Dim J As Integer

Dim identifier As String
Dim rowBlock As String

Dim props() As Variant
Dim K As Integer
Dim createdEntryID As String
 
Select Case folderType
    
Case mdVariables.FOLDER_TYPE_CON
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    ROOT = "contact"
        
End Select

Dim xmlMapping As String
xmlMapping = ""

I = 0
position = 1
numItem = 0

On Error GoTo addItemContacts_Err

Set defaultFolderContacts = mdVariables.nameSpace.GetDefaultFolder(olFolderContacts)

ret = getElementContent(xml, "NEW", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    
    numItem = getElementContent(ret, "numItems", 0)
    
    For I = 0 To Val(numItem) - 1
        ChangeStatusBar WAIT_PROCESSING_INSERT + "(" + Str(I + 1) + "/" + Str(numItem) + ")"
        rowBlock = getElementContent(ret, "row", position)
                
        identifier = getElementContent(rowBlock, "identifier", 0)
        el = getElementContent(rowBlock, ROOT, 0)
        
        If el <> Empty Then
            
            numItemValid = numItemValid + 1
            
            For K = 1 To UBound(props)
                If folderType = FOLDER_TYPE_CON Then
                    Dim tmp As Variant
                    
                    props(K, 0) = mdVariables.contactsProperties(K).Property
                    tmp = returnElementDataTypeCorrect(props(K, 0), _
                        getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0))
                    props(K, 1) = tmp
                                    
                End If
                
            Next K
            
            ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
           
            createdEntryID = insertContact(rowBlock, props)
           
            '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            
            'Create mapping for return data to dll
            xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
            xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
        Else
        
            printLog "Wrong format. Element dropped: " & rowBlock, INFO_LEVEL
            droppedItems = droppedItems + 1
        End If
        
    Next
    
    numItemValid = numItemValid + countInsertedItems
    
    xmlMapping = "<numItems>" + Str(numItemValid) + "</numItems>" + xmlMapping
    
    logToDebug xmlMapping
End If

'if there are no numItemValid but only item inserted by update...

If numItemValid = 0 And countInsertedItems <> 0 Then

    xmlMapping = "<numItems>" + Str(countInsertedItems) + "</numItems>"

End If

addItemContacts = xmlMapping

addItemContacts_Exit:
    Exit Function
    
addItemContacts_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo addItemContacts_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Function


Public Sub populateRecProps(ByRef RecProps As Variant, ByVal rowBlock As String)
        
    Dim recurrenceType As Long
    Dim interval As Long
    Dim monthOfYear As Long
    Dim dayOfMonth As Long
    Dim dayOfWeekMask As Long
    Dim instance As Long
    Dim patternStartDate As String
    Dim patterEndDate As String
    Dim noEndDate As Boolean
    Dim startAppointment As Date
    Dim startAppointmentString As String
    Dim tmp As String
    
    
    Dim x, y, z As Integer
    Dim changeDay, isBackward, changeYearBackward, changeYearForward   As Boolean
    changeDay = False
    isBackward = False
    changeYearBackward = False
    changeYearForward = False
    
    startAppointmentString = mdMMVariables.getElementContent(rowBlock, "Start", 0)
    If IsDate(mdMMTimeUtils.dateToCanonical(startAppointmentString)) Then
        If InStr(startAppointmentString, "Z") <> 0 Then
            startAppointment = CDate(mdMMTimeUtils.dateToCanonical(startAppointmentString))
            x = DatePart("h", startAppointment)
            startAppointment = mdMMTimeUtils.UTCToLocal(startAppointment)
            y = DatePart("h", startAppointment)
        Else
            startAppointment = CDate(mdMMTimeUtils.dateToCanonical(startAppointmentString))
            x = DatePart("h", startAppointment)
            y = DatePart("h", startAppointment)
        End If
    Else
        Exit Sub
    End If
        
    recurrenceType = mdMMVariables.getElementContent(rowBlock, "RecurrenceType", 0)
    
    tmp = mdMMVariables.getElementContent(rowBlock, "Interval", 0)
    If tmp <> Empty And tmp <> "" Then
        interval = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "DayOfMonth", 0)
    If tmp <> Empty And tmp <> "" Then
        dayOfMonth = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "MonthOfYear", 0)
    If tmp <> Empty And tmp <> "" Then
        monthOfYear = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "DayOfWeekMask", 0)
    If tmp <> Empty And tmp <> "" Then
        dayOfWeekMask = Val(tmp)
    End If
   
    tmp = mdMMVariables.getElementContent(rowBlock, "Instance", 0)
    If tmp <> Empty And tmp <> "" Then
        instance = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "PatternStartDate", 0)
    If IsDate(mdMMTimeUtils.dateToCanonical(tmp)) Then
        If InStr(tmp, "Z") <> 0 Then
            patternStartDate = mdMMTimeUtils.UTCToLocal(CDate(mdMMTimeUtils.dateToCanonical(tmp)))
        Else
            patternStartDate = CDate(mdMMTimeUtils.dateToCanonical(tmp))
        End If
    Else
        patternStartDate = Empty
    End If
       
    tmp = mdMMVariables.getElementContent(rowBlock, "PatternEndDate", 0)
    If IsDate(mdMMTimeUtils.dateToCanonical(tmp)) Then
        If InStr(tmp, "Z") <> 0 Then
            PatternEndDate = mdMMTimeUtils.UTCToLocal(CDate(mdMMTimeUtils.dateToCanonical(tmp)))
        Else
            PatternEndDate = CDate(mdMMTimeUtils.dateToCanonical(tmp))
        End If
    Else
       PatternEndDate = Empty
    End If
        
    tmp = mdMMVariables.getElementContent(rowBlock, "NoEndDate", 0)
    If tmp = "True" Then
        noEndDate = True
    Else
        noEndDate = False
    End If
    
                                                    
    If x - y < 0 Then
        z = (x - y) * (-1)
    Else
        z = x - y
    End If
    
    If z > 12 Then
        changeDay = True
    Else
        changeDay = False
    End If
    
    If changeDay = True Then
        If getTimeZoneInfo = True Then
            isBackward = False
        Else
            isBackward = True
        End If
            
    End If
    
    'Assing every Value to for the property
     'Assing every Value to for the property
    RecProps(0, 0) = "RecurrenceType"
    RecProps(0, 1) = recurrenceType
    
    
    RecProps(1, 0) = "Interval"
    RecProps(1, 1) = interval
    
    
    If dayOfMonth <> 0 Then
            If changeDay = True Then
                If isBackward = True Then
                    dayOfMonth = dayOfMonth - 1
                    If dayOfMonth = 0 Then
                        If monthOfYear = 5 Or monthOfYear = 7 Or monthOfYear = 10 Then
                            ' if May, July, October the month before has 30 days
                            dayOfMonth = 30
                        Else
                            dayOfMonth = 31
                        End If
                            changeYearBackward = True
                    End If
                Else
                    dayOfMonth = dayOfMonth + 1
                    If dayOfMonth > 31 Or (dayOfMonth = 31 And (monthOfYear = 4 Or monthOfYear = 6 Or monthOfYear = 9)) Then
                        dayOfMonth = 1
                        changeYearForward = True
                    End If
                End If
            End If
            RecProps(2, 0) = "DayOfMonth"
            RecProps(2, 1) = dayOfMonth
            
     Else
        RecProps(2, 0) = "DayOfMonth"
        RecProps(2, 1) = 0
        
     End If
    
     If monthOfYear <> 0 Then
            If changeYearBackward = True Then
                monthOfYear = monthOfYear - 1
                If monthOfYear = 0 Then
                    monthOfYear = 12
                End If
            ElseIf changeYearForward = True Then
                monthOfYear = monthOfYear + 1
                If monthOfYear > 12 Then
                    monthOfYear = 1
                End If
            End If
            RecProps(3, 0) = "MonthOfYear"
            RecProps(3, 1) = monthOfYear
      Else
        RecProps(3, 0) = "MonthOfYear"
        RecProps(3, 1) = 0
            
      End If
    
      If dayOfWeekMask <> 0 Then
            If changeDay = True Then
                If isBackward = True Then
                    dayOfWeekMask = convertDayOfWeekMaskBackward(dayOfWeekMask)
                Else
                    dayOfWeekMask = convertDayOfWeekMaskForward(dayOfWeekMask)
                End If
            End If
            RecProps(4, 0) = "DayOfWeekMask"
            RecProps(4, 1) = dayOfWeekMask
     Else
        RecProps(4, 0) = "DayOfWeekMask"
        RecProps(4, 1) = 0
     End If
     
     If instance <> 0 Then
        RecProps(5, 0) = "Instance"
        RecProps(5, 1) = instance
            
     Else
        RecProps(5, 0) = "Instance"
        RecProps(5, 1) = 0
     End If
     
     RecProps(6, 0) = "PatternStartDate"
     RecProps(6, 1) = patternStartDate
     
     RecProps(7, 0) = "PatternEndDate"
     RecProps(7, 1) = PatternEndDate
     
     RecProps(8, 0) = "NoEndDate"
     RecProps(8, 1) = noEndDate
     

End Sub

Public Function getRecurrenceValue(ByRef RecProps() As Variant, ByVal propertyName As String)

    Dim I, up As Integer
    up = UBound(RecProps)
    For I = 0 To up
        If RecProps(I, 0) = propertyName Then
            getRecurrenceValue = RecProps(I, 1)
            Exit Function
        End If
        
    Next I

End Function


'from server to outlook
Function addItem(ByRef xml As String, ByRef folderType As Integer, ByRef countInsertedItems As Integer)

Dim ret As String
Dim el As String
Dim ROOT As String

Dim position As Long
Dim numItem As Integer
Dim numItemValid As Integer
numItemValid = 0

Dim I As Integer
Dim J As Integer

Dim identifier As String
Dim rowBlock As String

Dim props() As Variant
Dim K As Integer

Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    'ROOT = "calendar"
    ROOT = ROOT_CAL_NAME
    
Case mdVariables.FOLDER_TYPE_CON
    'writingLine = "Contacts"
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    ROOT = "contact"

Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Task"
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    ROOT = "task"
    
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Note"
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    ROOT = "note"
        
End Select


Dim xmlMapping As String
xmlMapping = ""

I = 0
position = 1
numItem = 0

ret = getElementContent(xml, "NEW", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    
    numItem = getElementContent(ret, "numItems", 0)
    'xmlMapping = xmlMapping + "<numItems>" + Str(numItem) + "</numItems>"
    For I = 0 To Val(numItem) - 1
        
        Dim createdEntryID As String
        
        rowBlock = getElementContent(ret, "row", position)
                
        identifier = getElementContent(rowBlock, "identifier", 0)
        el = getElementContent(rowBlock, ROOT, 0)
        
        If el <> Empty Then
            numItemValid = numItemValid + 1
            
            If folderType = FOLDER_TYPE_CON Then
                'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
            ElseIf folderType = FOLDER_TYPE_TASK Then
                props(0, 0) = "Class"
                props(0, 1) = 26
                            
             ElseIf folderType = FOLDER_TYPE_CAL Then
                props(0, 0) = "Class"
                props(0, 1) = 26
                
                'for recurrences
                Dim RecProps() As Variant
                ReDim RecProps(0 To 9, 0 To 1)
                mdMMServer2Client.populateRecProps RecProps, rowBlock
                
            End If
                   
            For K = 1 To UBound(props)
                If folderType = FOLDER_TYPE_CON Then
                    Dim tmp As Variant
                    
                    props(K, 0) = mdVariables.contactsProperties(K).Property
                    tmp = returnElementDataTypeCorrect(props(K, 0), _
                        getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0))
                    props(K, 1) = tmp
                    
                ElseIf folderType = FOLDER_TYPE_CAL Then
                        
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        
                        If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) Then
                            props(K, 1) = getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                            
                        Else
                            'put right type to every property. If date is empty put nothing
                            tmp = returnElementDataTypeCorrect(props(K, 0), _
                                getElementContent(rowBlock, mdVariables.calendarProperties(K).Property, 0))
                             
                            props(K, 1) = tmp
                        End If
                ElseIf folderType = FOLDER_TYPE_TASK Then
                        
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        'put right type to every property. If date is empty put nothing
                        tmp = returnElementDataTypeCorrect(props(K, 0), _
                         getElementContent(rowBlock, mdVariables.tasksProperties(K).Property, 0))
                        props(K, 1) = tmp
                
                ElseIf folderType = FOLDER_TYPE_NOTE Then
                    If mdVariables.notesProperties(K).Property <> "Subject" Then
                        
                        Dim tmpNote As Variant
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        tmpNote = defaultNoteValues(props(K, 0), getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0))
                        props(K, 1) = tmpNote
                        
                        'props(K, 1) = getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0)
                    End If
                
                End If
                
            Next K
                                      
            If folderType = FOLDER_TYPE_CON Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
            ElseIf folderType = FOLDER_TYPE_CAL Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CAL, props)
            ElseIf folderType = FOLDER_TYPE_TASK Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_TASK, props)
            ElseIf folderType = FOLDER_TYPE_NOTE Then
                createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_NOTE, props)
            End If
            
            If createdEntryID = "-1" Then 'error in adding an item. log it at info level
                printLog ERROR_INSERTING_NEW_ITEM & rowBlock, INFO_LEVEL
                droppedItems = droppedItems + 1
            Else
                'Create mapping for return data to dll
                xmlMapping = xmlMapping + "<luid>" + createdEntryID + "</luid>"
                xmlMapping = xmlMapping + "<guid>" + identifier + "</guid>"
            End If
        Else
        
            printLog "Wrong format. Element dropped: " & rowBlock, INFO_LEVEL
            droppedItems = droppedItems + 1
        End If
        
    Next
    
    numItemValid = numItemValid + countInsertedItems
    
    xmlMapping = "<numItems>" + Str(numItemValid) + "</numItems>" + xmlMapping
    
    logToDebug xmlMapping
End If

'if there are no numItemValid but only item inserted by update...

If numItemValid = 0 And countInsertedItems <> 0 Then

    xmlMapping = "<numItems>" + Str(countInsertedItems) + "</numItems>"

End If

addItem = xmlMapping

End Function

'from server to outlook
Function deleteItem(ByRef xml As String)

Dim ret As String

Dim position As Long
Dim numItem As Integer
Dim I As Integer
Dim identifier As String
Dim rowBlock As String

I = 0

position = 1

ret = getElementContent(xml, "DEL", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    numItem = getElementContent(ret, "numItems", 0)
    For I = 0 To Val(numItem) - 1
        ChangeStatusBar WAIT_PROCESSING_DELETE + "(" + Str(I + 1) + "/" + Str(numItem) + ")"
        rowBlock = getElementContent(ret, "row", position)

        identifier = getElementContent(rowBlock, "identifier", 0)
                
        mdActions.removeItem identifier
        
    Next

End If

deleteItem = "ok"

End Function

